"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var spawn = require("node:child_process").spawn;
var path = require("node:path");
var ServerlessLambdaLayerNpmInstaller = /** @class */ (function () {
    function ServerlessLambdaLayerNpmInstaller(serverless, options, logging) {
        var _this = this;
        this.serverless = serverless;
        this.hooks = {
            "before:package:initialize": function () { return _this.runNpmInstall(); },
            "before:deploy:deploy": function () { return _this.runNpmInstall(); },
            "before:deploy:function:initialize": function () { return _this.runNpmInstall(); },
        };
        this.log = logging.log;
    }
    ServerlessLambdaLayerNpmInstaller.prototype.runNpmInstall = function () {
        return __awaiter(this, void 0, void 0, function () {
            var layers, entries, currentDirectory, command, args, options, _i, entries_1, _a, name_1, layer, layerPath;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        layers = this.serverless.service.layers;
                        if (!layers)
                            return [2 /*return*/];
                        entries = Object.entries(layers);
                        if (entries.length <= 0)
                            return [2 /*return*/];
                        currentDirectory = process.cwd();
                        args = ["install"];
                        options = {};
                        if (process.platform === "win32") {
                            command = "npm.cmd";
                            options.shell = true;
                        }
                        else {
                            command = "npm";
                        }
                        _i = 0, entries_1 = entries;
                        _b.label = 1;
                    case 1:
                        if (!(_i < entries_1.length)) return [3 /*break*/, 4];
                        _a = entries_1[_i], name_1 = _a[0], layer = _a[1];
                        this.log.notice("Start running npm install on Lambda layer: ".concat(name_1));
                        layerPath = layer.path;
                        if (!layerPath) {
                            throw new this.serverless.classes.Error("Missing path: ".concat(name_1));
                        }
                        options.cwd = path.join(currentDirectory, layerPath);
                        return [4 /*yield*/, this.runCommand(command, args, options)];
                    case 2:
                        _b.sent();
                        this.log.notice("NPM install success on Lambda layer: ".concat(name_1));
                        _b.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ServerlessLambdaLayerNpmInstaller.prototype.runCommand = function (command, args, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var npm = spawn(command, args, options);
                        npm.stdout.on("data", function (data) { return _this.log.info(data.toString()); });
                        npm.stderr.on("data", function (data) { return _this.log.error(data.toString()); });
                        npm.on("error", reject);
                        npm.on("exit", resolve);
                    })];
            });
        });
    };
    return ServerlessLambdaLayerNpmInstaller;
}());
module.exports = ServerlessLambdaLayerNpmInstaller;
